function [fpred, uniquedata, holdM, holdsigmasq_stat, holdlengthscale, mupred] = normal_GaussP(data1, target, ypred, burnin, numbofits, every)

data = unique(data1);
x = zeros(1, length(target));
for i = 1:length(target)
    x(i) = find(abs(data1(i) - data)<10^(-3));
end
uniquedata = data;

mix_a = 0.1;
mix_sigmasq = var(target);
mix_mu = mean(target);

mu = 0;

n = length(target);
ndata = length(data);
s = mod(1:n, 20) + 1;
v = 0.1 * ones(1, n);
M = 1;

DCV = 1;

dist = zeros(ndata, ndata);
for j = 1:ndata
    for k = 1:ndata
        dist(j, k) = norm(data(j) - data(k));
    end
end

logvsd = log(0.01) * ones(1, n);
logvsd2 = log(0.01);
logJsd = log(0.01);

sumysq = zeros(max(s), 1);
sumy = zeros(max(s), 1);
numb = zeros(max(s), 1);

for i = 1:n
    sumysq(s(i)) = sumysq(s(i)) + target(i)^2;
    sumy(s(i)) = sumy(s(i)) + target(i);
    numb(s(i)) = numb(s(i)) + 1;
end

Klimit = 10^5;

sigmasqnu = 5;
J = gamrnd(numb, 1 / (1 + sum(v)));
if ( DCV == 1 )
    sigmasq_loc = 1 ./ gamrnd(sigmasqnu / 2, 2 / sigmasqnu, length(numb), 1);
else
    sigmasq_loc = ones(1, length(numb));
end

sigmasq_stata = 1;
sigmasq_statb = 4;
lengthscalea = 1;
lengthscaleb = 1;

lengthscale = lengthscalea / lengthscaleb;
sigmasq_stat = sigmasq_stata / sigmasq_statb;

C = exp(- dist / lengthscale);
invC = inv(C);
%cholC = chol(C)';

% beta = zeros(length(numb), ndata);
% for i = 1:length(numb)
%     beta(i, :) = sqrt(sigmasq_stat) * cholC * randn(ndata, 1);
% end
beta = mvnrnd(zeros(ndata, 1), sigmasq_stat * C, length(numb));

%vstar = zeros(1, nstar);

a = 8;
b = 0.65;

wstar2 = (b - b * log(b)) / (b - b * log(b) - log(b));

betastar = cell(1, n);
Jstar = cell(1, n);
fstar = cell(1, n);
gstar = cell(1, n);
newbetastar = cell(1, n);
newJstar = cell(1, n);
newfstar = cell(1, n);
newgstar = cell(1, n);
logtheta_comp = zeros(1, n);
newlogtheta_comp = zeros(1, n);

K = poissrnd(a * M * v .* exp(0.5 * sigmasq_stat) * (b - b * log(b) - log(b)));
sumK = sum(K);
draw1 = mvnrnd(zeros(ndata, 1), sigmasq_stat * C, sum(K));
count1 = 0;
for j1 = 1:n
    betastar{1, j1} = zeros(K(j1), ndata);
    Jstar{1, j1} = zeros(1, K(j1));
    fstar{1, j1} = zeros(1, K(j1));
    gstar{1, j1} = zeros(1, K(j1));
    x2 = zeros(1, K(j1));
    if ( K(j1) == 0 )
        logtheta_comp(j1) = 0;
    else
        betastar{1, j1} = ones(K(j1), 1) * sigmasq_stat * C(x(j1), :) + draw1((count1+1):(count1+K(j1)), :);
        count1 = count1 + 1;
        
        for k1 = 1:K(j1)
            if ( rand < wstar2 )
                z = - log(b) - 1;
                while ( z < - log(b) )
                    z = gamrnd(2, 1);
                end
                Jstar{1, j1}(k1) = exp(- z);
                gstar{1, j1}(k1) = - log(Jstar{1, j1}(k1));
            else
                Jstar{1, j1}(k1) = b - log(rand);
                gstar{1, j1}(k1) = - log(b) * exp(- (Jstar{1, j1}(k1) - b));
            end
            x2(k1) = exp(- Jstar{1, j1}(k1) * sum(v .* exp(betastar{1, j1}(k1, x))));
        end
        fstar{1, j1} = expint(Jstar{1, j1});
        logtheta_comp(j1) = sum(log(1 - x2.*fstar{1, j1}./(a*gstar{1, j1})));
    end
end
logtheta = sum(logtheta_comp);

logbetasd = log(0.01) * ones(1, ndata);
logbetasd2 = log(0.01);
logsigmasq_statsd = log(0.01);
logsigmasq_statsd2 = log(0.01);
loglengthscalesd = log(0.01);
loglengthscalesd2 = log(0.01);
logMsd = log(0.01);

mix_aaccept = 0;
mix_acount = 0;
sigmasq_stataccept = 0;
sigmasq_statcount = 0;
sigmasq_stataccept2 = 0;
sigmasq_statcount2 = 0;
lengthscaleaccept = 0;
lengthscalecount = 0;
lengthscaleaccept2 = 0;
lengthscalecount2 = 0;
betaaccept = zeros(1, ndata);
betacount = zeros(1, ndata);
betaaccept2 = 0;
betacount2 = 0;
vaccept = zeros(1, n);
vcount = zeros(1, n);
vaccept2 = 0;
vcount2 = 0;
Jaccept = 0;
Jcount = 0;
Maccept = 0;
Mcount = 0;

holdsigmasq_stat = zeros(1, numbofits);
holdlengthscale = zeros(1, numbofits);
holdv = zeros(numbofits, n);
holdmix_mu = zeros(1, numbofits);
holdmix_sigmasq = zeros(1, numbofits);
holdmix_a = zeros(1, numbofits);
holdM = zeros(1, numbofits);

fpred = zeros(ndata, length(ypred));
mupred = zeros(ndata, numbofits);

logmix_asd = log(0.01);

numbclust = zeros(1, numbofits);
for it = 1:(burnin + every * numbofits)
    
    
    if ( mod(it, 10) == 0 )
        %         figure(1)
        %         plot(target, s, '.')
        %         drawnow
        %
        %         figure(2)
        %         pcolor(data, ypred, fpred')
        %         shading flat
        %         hold on
        %         plot(data(x), target, '.')
        %         hold off

        disp(['it = ' num2str(it)]);
        disp(['numbclust = ' num2str(length(unique(s)))]);
        disp(['M = ' num2str(M)]);
        disp(['mix_a = ' num2str(mix_a)]);
        disp(['mix_mu = ' num2str(mix_mu)]);
        disp(['mix_sigmasq = ' num2str(mix_sigmasq)]);
        disp(['sigmasq_stat = ' num2str(sigmasq_stat)]);
        disp(['lengthscale = ' num2str(lengthscale')]);
        disp(['v = ' num2str(max(v))]);
        disp(['M accept = ' num2str(Maccept/Mcount)]);
        disp(['J accept = ' num2str(Jaccept/Jcount)]);
        disp(['sigmasq_stat accept = ' num2str(sigmasq_stataccept/sigmasq_statcount)]);
        disp(['sigmasq_stat accept2 = ' num2str(sigmasq_stataccept2/sigmasq_statcount2)]);
        disp(['lengthscale accept = ' num2str(lengthscaleaccept/lengthscalecount)]);
        disp(['lengthscale accept2 = ' num2str(lengthscaleaccept2/lengthscalecount2)]);
        disp(['mix_a accept = ' num2str(mix_aaccept/mix_acount)]);
        disp(['v accept = ' num2str(min(vaccept./vcount)) ' ' num2str(max(vaccept./vcount))]);
%        disp(['beta accept = ' num2str(min(betaaccept./betacount)) ' ' num2str(max(betaaccept./betacount))]);
        disp(['beta accept2 = ' num2str((betaaccept2/betacount2))]);
        disp(['v accept2 = ' num2str(vaccept2/vcount2)]);
        disp(' ');
    end
    
    
    for i1 = 1:40
        i = ceil(rand * n);
        % Update v
        newv = v;
        newv(i) = v(i) * exp(exp(logvsd(i)) * randn);
        
        K = poissrnd(a * M * newv(i) * exp(0.5 * sigmasq_stat) * (b - b * log(b) - log(b)));
        newsumK = sumK + K - length(Jstar{1, i});
        
        if ( newsumK > Klimit )
            accept = 0;
        else           
            newJstar{1, i} = zeros(1, K);
            newfstar{1, i} = zeros(1, K);
            newgstar{1, i} = zeros(1, K);
            
            if ( K == 0 )
                newlogtheta_comp(i) = 0;
            else
                for k1 = 1:K
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, i}(k1) = exp(- z);
                        newgstar{1, i}(k1) = - log(newJstar{1, i}(k1));
                    else
                        newJstar{1, i}(k1) = b - log(rand);
                        newgstar{1, i}(k1) = - log(b) * exp(- (newJstar{1, i}(k1) - b));
                    end
                end
                newbetastar{1, i} = mvnrnd(sigmasq_stat * C(x(i), :), sigmasq_stat * C, K);
                
                newfstar{1, i} = expint(newJstar{1, i});
                x2 = exp(- newJstar{1, i} .* (newv * exp(newbetastar{1, i}(:, x)')));
                
                newlogtheta_comp(i) = sum(log(1 - x2.*newfstar{1, i}./(a*newgstar{1, i})));
            end
            
            for j1 = 1:(i-1)
                K = length(Jstar{1, j1});
                if ( K == 0 )
                    newlogtheta_comp(j1) = 0;
                else
                    x2 = exp(- Jstar{1, j1} .* (newv * exp(betastar{1, j1}(:, x)')));
                    newlogtheta_comp(j1) = sum(log(1 - x2.*fstar{1, j1}./(a*gstar{1, j1})));
                end
            end
            for j1 = (i+1):n
                K = length(Jstar{1, j1});
                if ( K == 0 )
                    newlogtheta_comp(j1) = 0;
                else
                    x2 = exp(- Jstar{1, j1} .* (newv * exp(betastar{1, j1}(:, x)')));
                    newlogtheta_comp(j1) = sum(log(1 - x2.*fstar{1, j1}./(a*gstar{1, j1})));
                end
            end
            
            newlogtheta = sum(newlogtheta_comp);
            
            newloglike = newlogtheta + log(newv(i));
            loglike = logtheta + log(v(i));
            newloglike = newloglike - sum(J .* (newv * exp(beta(:, x))')');
            loglike = loglike - sum(J .* (v * exp(beta(:, x))')');
            
            logaccept = newloglike - loglike;
            
            accept = 1;
            if ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
                accept = 0;
            elseif ( logaccept < 0 )
                accept = exp(logaccept);
            end
        end
        
        vaccept(i) = vaccept(i) + accept;
        vcount(i) = vcount(i) + 1;
        
        if ( rand < accept )
            v(i) = newv(i);
            logtheta = newlogtheta;
            logtheta_comp = newlogtheta_comp;
            betastar{1, i} = newbetastar{1, i};
            Jstar{1, i} = newJstar{1, i};
            fstar{1, i} = newfstar{1, i};
            gstar{1, i} = newgstar{1, i};
            sumK = newsumK;
        end
        
        if ( isreal(accept) == 0 )
            stop;
        end
        
        logvsd(i) = logvsd(i) + 1 / it^0.55 * (accept - 0.234);
        if ( logvsd(i) > 2 )
            logvsd(i) = 2;
        end
    end
    
    
    for i = 1:n
        
        olds = s(i);
        
        if ( numb(s(i)) == 1 )
            logprob = zeros(1, length(numb));
        else
            logprob = zeros(1, length(numb) + 1);
        end
        
        logprob(1:length(numb)) = log(J) + beta(:, x(i));
        
        meanstar = (sumy ./ (mix_a * sigmasq_loc) + mix_mu / (1 - mix_a)) ./ (numb ./ (mix_a * sigmasq_loc) + 1 / (1 - mix_a));
        varstar = mix_sigmasq ./ (numb ./ (mix_a * sigmasq_loc) + 1 / (1 - mix_a));
        
        for j = 1:length(numb)
            if ( j ~= s(i) )
                var1 = varstar(j) + mix_a * mix_sigmasq * sigmasq_loc(j);
                logprob(j) = logprob(j) - 0.5 * (target(i) - meanstar(j))^2 / var1 - 0.5 * log(var1);
            end
        end
        
        if ( numb(s(i)) == 1 )
            var1 = mix_sigmasq * (mix_a * sigmasq_loc(s(i)) + (1 - mix_a));
            
            logprob(s(i)) = log(M) + beta(s(i), x(i)) - log(1 + sum(v .* exp(beta(s(i), x)))) - 0.5 * (target(i) - mix_mu)^2 / var1 - 0.5 * log(var1);
        else 
            newbeta = mvnrnd(zeros(ndata, 1), sigmasq_stat * C);
            newJ = gamrnd(1, 1 / (1 + sum(v .* exp(newbeta(:, x)))));
            if ( DCV == 1 )
                newsigmasq_loc = 1 / gamrnd(sigmasqnu / 2, 2 / sigmasqnu);
            else
                newsigmasq_loc = 1;
            end
            
            meanstar = ((sumy(s(i)) - target(i)) / (mix_a * sigmasq_loc(s(i))) + mix_mu / (1 - mix_a)) / ((numb(s(i)) - 1) / (mix_a * sigmasq_loc(s(i))) + 1 / (1 - mix_a));
            varstar = mix_sigmasq / ((numb(s(i)) - 1) / (mix_a * sigmasq_loc(s(i))) + 1 / (1 - mix_a));
            
            var1 = varstar + mix_a * mix_sigmasq * sigmasq_loc(s(i));
            logprob(s(i)) = logprob(s(i)) - 0.5 * (target(i) - meanstar)^2 / var1 - 0.5 * log(var1);
            
            var1 = mix_sigmasq * (mix_a * newsigmasq_loc + (1 - mix_a));
            logprob(length(numb) + 1) = log(M) + newbeta(x(i)) - log(1 + sum(v .* exp(newbeta(x)))) - 0.5 * (target(i) - mix_mu)^2 / var1 - 0.5 * log(var1);
        end
        
        prob = exp(logprob - max(logprob));
        fprob = cumsum(prob);
        fprob = fprob / fprob(end);
        
        u = rand;
        s(i) = 1;
        while ( fprob(s(i)) < u )
            s(i) = s(i) + 1;
        end
        
        sumysq(olds) = sumysq(olds) - target(i)^2;
        sumy(olds) = sumy(olds) - target(i);
        numb(olds) = numb(olds) - 1;
        
        if ( s(i) > length(numb) )
            sumysq = [sumysq; target(i)^2];
            sumy = [sumy; target(i)];
            numb = [numb; 1];
            J = [J; newJ];
            beta = [beta; newbeta];
            sigmasq_loc = [sigmasq_loc; newsigmasq_loc];
        else
            sumysq(s(i)) = sumysq(s(i)) + target(i)^2;
            sumy(s(i)) = sumy(s(i)) + target(i);
            numb(s(i)) = numb(s(i)) + 1;
        end
        if ( sum(numb(olds, :)) == 0 )
            sumysq = [sumysq(1:(olds-1)); sumysq((olds+1):length(sumysq))];
            sumy = [sumy(1:(olds-1)); sumy((olds+1):length(sumy))];
            numb = [numb(1:(olds-1)); numb((olds+1):length(numb))];
            J = [J(1:(olds-1)); J((olds+1):length(J))];
            beta = [beta(1:(olds-1), :); beta((olds+1):size(beta, 1), :)];
            s(s > olds) = s(s > olds) - 1;
            sigmasq_loc(olds) = [];
        end
    end
    
    
    
    for j = 1:length(numb)
        J(j) = gamrnd(numb(j), 1 / (1 + sum(v .* exp(beta(j, x)))));
        
        for j1 = 1:10
            xstar = zeros(1, ndata);
            while ( sum(xstar)==0 )
                xstar = rand(1, ndata) < 5 / ndata;
            end
            mean1 = C(xstar==1, xstar==0) * (C(xstar==0, xstar==0) \ (beta(j, xstar==0)'));
            var1 = sigmasq_stat * (C(xstar==1, xstar==1) - C(xstar==1, xstar==0) * (C(xstar==0, xstar==0) \ C(xstar==0, xstar==1)));
            var1 = 0.5 * (var1 + var1');
            
            newbeta = beta(j, :);
            newbeta(xstar==1) = mvnrnd(newbeta(xstar==1), exp(logbetasd2) * var1);
            
            loglike = - sum(v .* exp(beta(j, x))) * J(j);
            newloglike = - sum(v .* exp(newbeta(x))) * J(j);
            for k = 1:ndata
                if ( xstar(k) == 1 )
                    loglike = loglike + sum((s==j).*(x==k)) * beta(j, k);
                    newloglike = newloglike + sum((s==j).*(x==k)) * newbeta(k);
                end
            end
            
            invvar1 = inv(var1);
            loglike = loglike - 0.5 * (beta(j, xstar) - mean1') * invvar1 * (beta(j, xstar) - mean1')';
            newloglike = newloglike - 0.5 * (newbeta(xstar) - mean1') * invvar1 * (newbeta(xstar) - mean1')';
            %
            
            
            %             for k = 1:ndata
            %                 newbeta = beta(j, :);
            %                 newbeta(k) = beta(j, k) + exp(logbetasd(k)) * randn;
            %
            %                 loglike = sum((s==j).*(x==k)) * beta(j, k) - sum(v .* exp(beta(j, x)) * J(j));
            %                 newloglike = sum((s==j).*(x==k)) * newbeta(k) - sum(v .* exp(newbeta(x)) * J(j));
            %
            %
            %                 x1 = [1:(k-1) (k+1):ndata];
            %                 mean1 = C(k, x1) * (C(x1, x1) \ (beta(j, x1)'));
            %                 var1 = C(k, k) - C(k, x1) * (C(x1, x1) \ C(x1, k));
            %                 loglike = loglike - 0.5 * (beta(j, k) - mean1)^2 / (sigmasq_stat * var1);
            %                 newloglike = newloglike - 0.5 * (newbeta(k) - mean1)^2 / (sigmasq_stat * var1);
            %
            logaccept = newloglike - loglike;
            accept = 1;
            if ( logaccept < 0 )
                accept = exp(logaccept);
            end
            
            if ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
                accept = 0;
            end
            %
            %                 betaaccept(k) = betaaccept(k) + accept;
            %                 betacount(k) = betacount(k) + 1;
            %
            %                 if ( rand < accept )
            %                     beta(j, k) = newbeta(k);
            %                 end
            %
            %                 logbetasd(k) = logbetasd(k) + 1 / it^(0.55) * (accept - 0.3);
            %             end
            %
            betaaccept2 = betaaccept2 + accept;
            betacount2 = betacount2 + 1;
            
            if ( rand < accept )
                beta(j, xstar) = newbeta(xstar);
            end
            
            logbetasd2 = logbetasd2 + 1 / it^(0.55) * (accept - 0.3);
        end
        
        newJ = J(j) * exp(exp(logJsd) * randn);
        
        x2 = beta(j, :) + log(J(j)) - log(J(j));
        loglike = - 0.5 * x2 * invC * x2' / sigmasq_stat - J(j);
        
        x2 = beta(j, :) + log(J(j)) - log(newJ);
        newloglike = - 0.5 * x2 * invC * x2' / sigmasq_stat - newJ;
        
        logaccept = newloglike - loglike;
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
        
        Jaccept = Jaccept + accept;
        Jcount = Jcount + 1;
        
        if ( rand < accept )
            beta(j, :) = beta(j, :) + log(J(j)) - log(newJ);
            J(j) = newJ;
        end
        
        logJsd = logJsd + 1 / it^(0.55) * (accept - 0.3);
    end
    
    
    for j = 1:length(numb)
        J(j) = gamrnd(numb(j), 1 / (1 + sum(v .* exp(beta(j, x)))));
        
        for j1 = 1:10
            xstar = zeros(1, ndata);
            while ( sum(xstar)==0 )
                xstar = rand(1, ndata) < 5 / ndata;
            end
            mean1 = C(xstar==1, xstar==0) * (C(xstar==0, xstar==0) \ (beta(j, xstar==0)'));
            var1 = sigmasq_stat * (C(xstar==1, xstar==1) - C(xstar==1, xstar==0) * (C(xstar==0, xstar==0) \ C(xstar==0, xstar==1)));
            var1 = 0.5 * (var1 + var1');
            
            newbeta = beta(j, :);
            newbeta(xstar==1) = mvnrnd(newbeta(xstar==1), exp(logbetasd2) * var1);
            
            loglike = - sum(v .* exp(beta(j, x))) * J(j);
            newloglike = - sum(v .* exp(newbeta(x))) * J(j);
            for k = 1:ndata
                if ( xstar(k) == 1 )
                    loglike = loglike + sum((s==j).*(x==k)) * beta(j, k);
                    newloglike = newloglike + sum((s==j).*(x==k)) * newbeta(k);
                end
            end
            
            invvar1 = inv(var1);
            loglike = loglike - 0.5 * (beta(j, xstar) - mean1') * invvar1 * (beta(j, xstar) - mean1')';
            newloglike = newloglike - 0.5 * (newbeta(xstar) - mean1') * invvar1 * (newbeta(xstar) - mean1')';
            
            logaccept = newloglike - loglike;
            accept = 1;
            if ( logaccept < 0 )
                accept = exp(logaccept);
            end
            
            if ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
                accept = 0;
            end
            
            betaaccept2 = betaaccept2 + accept;
            betacount2 = betacount2 + 1;
            
            if ( rand < accept )
                beta(j, xstar) = newbeta(xstar);
            end
            
            logbetasd2 = logbetasd2 + 1 / it^(0.55) * (accept - 0.234);
        end
        
        newJ = J(j) * exp(exp(logJsd) * randn);
        
        x2 = beta(j, :) + log(J(j)) - log(J(j));
        loglike = - 0.5 * x2 * invC * x2' / sigmasq_stat - J(j);
        
        x2 = beta(j, :) + log(J(j)) - log(newJ);
        newloglike = - 0.5 * x2 * invC * x2' / sigmasq_stat - newJ;
        
        logaccept = newloglike - loglike;
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
        
        Jaccept = Jaccept + accept;
        Jcount = Jcount + 1;
        
        if ( rand < accept )
            beta(j, :) = beta(j, :) + log(J(j)) - log(newJ);
            J(j) = newJ;
        end
        
        logJsd = logJsd + 1 / it^(0.55) * (accept - 0.234);
    end
    
    % Joint update v
    newv = v;
    
    newv(1) = v(1) * exp(exp(logvsd2) * randn);
    newv(2:end) = v(2:end) * newv(1) / v(1);
    newJ = J * v(1) / newv(1);
    
    K = poissrnd(a * M * newv * exp(0.5 * sigmasq_stat) * (b - b * log(b) - log(b)));
    
    
    if ( sum(K) > Klimit )
        accept = 0;
    else
        draw1 = mvnrnd(zeros(ndata, 1), sigmasq_stat * C, sum(K));
        count1 = 0;
        
        newlogtheta_comp = zeros(1, n);
        for j1 = 1:n
            newbetastar{1, j1} = zeros(K(j1), ndata);
            newJstar{1, j1} = zeros(1, K(j1));
            newfstar{1, j1} = zeros(1, K(j1));
            newgstar{1, j1} = zeros(1, K(j1));
            
            if ( K(j1) == 0 )
                newlogtheta_comp(j1) = 0;
            else
                newbetastar{1, j1} = ones(K(j1), 1) * sigmasq_stat * C(x(j1), :) + draw1((count1+1):(count1+K(j1)), :);
                count1 = count1 + K(j1);
                
                for k1 = 1:K(j1)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, j1}(k1) = exp(- z);
                        newgstar{1, j1}(k1) = - log(newJstar{1, j1}(k1));
                    else
                        newJstar{1, j1}(k1) = b - log(rand);
                        newgstar{1, j1}(k1) = - log(b) * exp(- (newJstar{1, j1}(k1) - b));
                    end
                end
                x2 = exp(- newJstar{1, j1} .* (newv * exp(newbetastar{1, j1}(:, x)')));
                newfstar{1, j1} = expint(newJstar{1, j1});
                newlogtheta_comp(j1) = sum(log(1 - x2.*newfstar{1, j1}./(a*newgstar{1, j1})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        loglike = logtheta;
        newloglike = newlogtheta;
        
        for j = 1:length(numb)
            loglike = loglike - sum(v .* exp(beta(j, x))) * J(j);
            newloglike = newloglike - sum(newv .* exp(beta(j, x))) * newJ(j);
            
            loglike = loglike + (numb(j) - 1) * log(J(j)) - J(j);
            newloglike = newloglike + (numb(j) - 1) * log(newJ(j)) - newJ(j);
        end
        
        logaccept = newloglike - loglike;
        logaccept = logaccept + (n - length(numb)) * (log(newv(1)) - log(v(1)));
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end
    
    if ( rand < accept )
        J = newJ;
        v = newv;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar = newbetastar;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    logvsd2 = logvsd2 + 1 / it^(0.55) * (accept - 0.234);
    
    vaccept2 = vaccept2 + accept;
    vcount2 = vcount2 + 1;
    
    
    
    
    % Update sigmasq_stat
    newsigmasq_stat = sigmasq_stat * exp(exp(logsigmasq_statsd) * randn);
    
    K = poissrnd(a * M * v .* exp(0.5 * newsigmasq_stat) * (b - b * log(b) - log(b)));
    
    if ( sum(K) > Klimit )
        accept = 0;
    else
        draw1 = mvnrnd(zeros(ndata, 1), newsigmasq_stat * C, sum(K));
        count1 = 0;
        
        newlogtheta_comp = zeros(1, n);
        for j1 = 1:n
            newbetastar{1, j1} = zeros(K(j1), ndata);
            newJstar{1, j1} = zeros(1, K(j1));
            newfstar{1, j1} = zeros(1, K(j1));
            newgstar{1, j1} = zeros(1, K(j1));
            
            if ( K(j1) == 0 )
                newlogtheta_comp(j1) = 0;
            else
                newbetastar{1, j1} = ones(K(j1), 1) * newsigmasq_stat * C(x(j1), :) + draw1((count1+1):(count1+K(j1)), :);
                count1 = count1 + K(j1);
                
                for k1 = 1:K(j1)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, j1}(k1) = exp(- z);
                        newgstar{1, j1}(k1) = - log(newJstar{1, j1}(k1));
                    else
                        newJstar{1, j1}(k1) = b - log(rand);
                        newgstar{1, j1}(k1) = - log(b) * exp(- (newJstar{1, j1}(k1) - b));
                    end
                end
                x2 = exp(- newJstar{1, j1} .* (v * exp(newbetastar{1, j1}(:, x)')));
                newfstar{1, j1} = expint(newJstar{1, j1});
                newlogtheta_comp(j1) = sum(log(1 - x2.*newfstar{1, j1}./(a*newgstar{1, j1})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        newloglike = newlogtheta;
        loglike = logtheta;
        
        for j1 = 1:length(numb)
            loglike = loglike - 0.5 * beta(j1, :) * invC * beta(j1, :)' / sigmasq_stat - 0.5 * ndata * log(sigmasq_stat);
            newloglike = newloglike - 0.5 * beta(j1, :) * invC * beta(j1, :)' / newsigmasq_stat - 0.5 * ndata * log(newsigmasq_stat);
        end
        
        logaccept = newloglike - loglike;
        logaccept = logaccept + log(newsigmasq_stat) - log(sigmasq_stat) - 2 * (newsigmasq_stat - sigmasq_stat);
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end
    
    if ( rand < accept )
        sigmasq_stat = newsigmasq_stat;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar = newbetastar;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    logsigmasq_statsd = logsigmasq_statsd + 1 / it^(0.55) * (accept - 0.234);
    
    sigmasq_stataccept = sigmasq_stataccept + accept;
    sigmasq_statcount = sigmasq_statcount + 1;
    
    
    
    
    % Update sigmasq_stat
    newsigmasq_stat = sigmasq_stat * exp(exp(logsigmasq_statsd2) * randn);
    
    K = poissrnd(a * M * v .* exp(0.5 * newsigmasq_stat) * (b - b * log(b) - log(b)));
    
    if ( sum(K) > Klimit )
        accept = 0;
    else
        draw1 = mvnrnd(zeros(ndata, 1), newsigmasq_stat * C, sum(K));
        count1 = 0;
        
        newlogtheta_comp = zeros(1, n);
        for j1 = 1:n
            newbetastar{1, j1} = zeros(K(j1), ndata);
            newJstar{1, j1} = zeros(1, K(j1));
            newfstar{1, j1} = zeros(1, K(j1));
            newgstar{1, j1} = zeros(1, K(j1));
            
            if ( K(j1) == 0 )
                newlogtheta_comp(j1) = 0;
            else
                newbetastar{1, j1} = ones(K(j1), 1) * newsigmasq_stat * C(x(j1), :) + draw1((count1+1):(count1+K(j1)), :);
                count1 = count1 + K(j1);
                
                for k1 = 1:K(j1)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, j1}(k1) = exp(- z);
                        newgstar{1, j1}(k1) = - log(newJstar{1, j1}(k1));
                    else
                        newJstar{1, j1}(k1) = b - log(rand);
                        newgstar{1, j1}(k1) = - log(b) * exp(- (newJstar{1, j1}(k1) - b));
                    end
                end
                x2 = exp(- newJstar{1, j1} .* (v * exp(newbetastar{1, j1}(:, x)')));
                newfstar{1, j1} = expint(newJstar{1, j1});
                newlogtheta_comp(j1) = sum(log(1 - x2.*newfstar{1, j1}./(a*newgstar{1, j1})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        newloglike = newlogtheta;
        loglike = logtheta;
        
        newbeta = beta;
        for j1 = 1:length(numb)
            newbeta(j1, :) = beta(j1, :) * sqrt(newsigmasq_stat / sigmasq_stat);
            
            loglike = loglike - sum(v .* exp(beta(j1, x))) * J(j1);
            newloglike = newloglike - sum(v .* exp(newbeta(j1, x))) * J(j1);
            
            loglike = loglike + sum(beta(j1, x(s==j1)));
            newloglike = newloglike + sum(newbeta(j1, x(s==j1)));
        end
        
        logaccept = newloglike - loglike;
        logaccept = logaccept + log(newsigmasq_stat) - log(sigmasq_stat) - 2 * (newsigmasq_stat - sigmasq_stat);
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end
    
    if ( rand < accept )
        sigmasq_stat = newsigmasq_stat;
        beta = newbeta;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar = newbetastar;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    logsigmasq_statsd2 = logsigmasq_statsd2 + 1 / it^(0.55) * (accept - 0.234);
    
    sigmasq_stataccept2 = sigmasq_stataccept2 + accept;
    sigmasq_statcount2 = sigmasq_statcount2 + 1;
    
    
    
    % Update lengthscale
    newlengthscale = lengthscale * exp(exp(loglengthscalesd) * randn);
    newC = exp(- dist / newlengthscale);
    newinvC = inv(newC);
    
    K = poissrnd(a * M * v .* exp(0.5 * sigmasq_stat) * (b - b * log(b) - log(b)));
    
    if ( sum(K) > Klimit )
        accept = 0;
    else
        draw1 = mvnrnd(zeros(ndata, 1), sigmasq_stat * newC, sum(K));
        count1 = 0;
        
        newlogtheta_comp = zeros(1, n);
        for j1 = 1:n
            newbetastar{1, j1} = zeros(K(j1), ndata);
            newJstar{1, j1} = zeros(1, K(j1));
            newfstar{1, j1} = zeros(1, K(j1));
            newgstar{1, j1} = zeros(1, K(j1));
            
            if ( K(j1) == 0 )
                newlogtheta_comp(j1) = 0;
            else
                newbetastar{1, j1} = ones(K(j1), 1) * sigmasq_stat * newC(x(j1), :) + draw1((count1+1):(count1+K(j1)), :);
                count1 = count1 + K(j1);
                
                for k1 = 1:K(j1)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, j1}(k1) = exp(- z);
                        newgstar{1, j1}(k1) = - log(newJstar{1, j1}(k1));
                    else
                        newJstar{1, j1}(k1) = b - log(rand);
                        newgstar{1, j1}(k1) = - log(b) * exp(- (newJstar{1, j1}(k1) - b));
                    end
                end
                x2 = exp(- newJstar{1, j1} .* (v * exp(newbetastar{1, j1}(:, x)')));
                newfstar{1, j1} = expint(newJstar{1, j1});
                newlogtheta_comp(j1) = sum(log(1 - x2.*newfstar{1, j1}./(a*newgstar{1, j1})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        newloglike = newlogtheta;
        loglike = logtheta;
        
        for j1 = 1:length(numb)
            loglike = loglike - 0.5 * beta(j1, :) * invC * beta(j1, :)' / sigmasq_stat;
            newloglike = newloglike - 0.5 * beta(j1, :) * newinvC * beta(j1, :)' / sigmasq_stat;
        end
        loglike = loglike - 0.5 * length(numb) * log(det(C));
        newloglike = newloglike - 0.5 * length(numb) * log(det(newC));
        
        logaccept = newloglike - loglike;
        logaccept = logaccept + lengthscalea * (log(newlengthscale) - log(lengthscale));
        logaccept = logaccept - lengthscaleb * (newlengthscale - lengthscale);
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end
    
    if ( rand < accept )
        lengthscale = newlengthscale;
        C = newC;
        invC = newinvC;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar = newbetastar;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    loglengthscalesd = loglengthscalesd + 1 / it^(0.55) * (accept - 0.234);
    
    lengthscaleaccept = lengthscaleaccept + accept;
    lengthscalecount = lengthscalecount + 1;
    
    
    
    
    % Update lengthscale
    newlengthscale = lengthscale * exp(exp(loglengthscalesd2) * randn);
    newC = exp(- dist / newlengthscale);
    newinvC = inv(newC);
    
    K = poissrnd(a * M * v .* exp(0.5 * sigmasq_stat) * (b - b * log(b) - log(b)));
    
    if ( sum(K) > Klimit )
        accept = 0;
    else
        draw1 = mvnrnd(zeros(ndata, 1), sigmasq_stat * newC, sum(K));
        count1 = 0;
        
        newlogtheta_comp = zeros(1, n);
        for j1 = 1:n
            newbetastar{1, j1} = zeros(K(j1), ndata);
            newJstar{1, j1} = zeros(1, K(j1));
            newfstar{1, j1} = zeros(1, K(j1));
            newgstar{1, j1} = zeros(1, K(j1));
            
            if ( K(j1) == 0 )
                newlogtheta_comp(j1) = 0;
            else
                newbetastar{1, j1} = ones(K(j1), 1) * sigmasq_stat * newC(x(j1), :) + draw1((count1+1):(count1+K(j1)), :);
                count1 = count1 + K(j1);
                
                for k1 = 1:K(j1)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, j1}(k1) = exp(- z);
                        newgstar{1, j1}(k1) = - log(newJstar{1, j1}(k1));
                    else
                        newJstar{1, j1}(k1) = b - log(rand);
                        newgstar{1, j1}(k1) = - log(b) * exp(- (newJstar{1, j1}(k1) - b));
                    end
                end
                x2 = exp(- newJstar{1, j1} .* (v * exp(newbetastar{1, j1}(:, x)')));
                newfstar{1, j1} = expint(newJstar{1, j1});
                newlogtheta_comp(j1) = sum(log(1 - x2.*newfstar{1, j1}./(a*newgstar{1, j1})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        newloglike = newlogtheta;
        loglike = logtheta;
        
        newbeta = beta;
        invcholC = inv(chol(C)');
        cholnewC = chol(newC)';
        change = cholnewC * invcholC;
        for j1 = 1:length(numb)
            newbeta(j1, :) = (change * beta(j1, :)')';
            
            loglike = loglike - sum(v .* exp(beta(j1, x))) * J(j1);
            newloglike = newloglike - sum(v .* exp(newbeta(j1, x))) * J(j1);
            
            loglike = loglike + sum(beta(j1, x(s==j1)));
            newloglike = newloglike + sum(newbeta(j1, x(s==j1)));
        end
        
        logaccept = newloglike - loglike;
        logaccept = logaccept + lengthscalea * (log(newlengthscale) - log(lengthscale));
        logaccept = logaccept - lengthscaleb * (newlengthscale - lengthscale);
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end
    
    if ( rand < accept )
        lengthscale = newlengthscale;
        C = newC;
        invC = newinvC;
        beta = newbeta;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar = newbetastar;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    loglengthscalesd2 = loglengthscalesd2 + 1 / it^(0.55) * (accept - 0.234);
    
    lengthscaleaccept2 = lengthscaleaccept2 + accept;
    lengthscalecount2 = lengthscalecount2 + 1;
    
    
    
    % Update M
    newM = M * exp(exp(logMsd) * randn);
    
    K = poissrnd(a * newM * v .* exp(0.5 * sigmasq_stat) * (b - b * log(b) - log(b)));
    
    if ( sum(K) > Klimit )
        accept = 0;
    else
        draw1 = mvnrnd(zeros(ndata, 1), sigmasq_stat * C, sum(K));
        count1 = 0;
        
        newlogtheta_comp = zeros(1, n);
        for i = 1:n
            newbetastar{1, i} = zeros(K(i), ndata);
            newJstar{1, i} = zeros(1, K(i));
            newfstar{1, i} = zeros(1, K(i));
            newgstar{1, i} = zeros(1, K(i));
            x2 = zeros(1, K(i));
            
            if ( K(i) == 0 )
                newlogtheta_comp(i) = 0;
            else
                newbetastar{1, i} = ones(K(i), 1) * sigmasq_stat * C(x(i), :) + draw1((count1+1):(count1+K(i)), :);
                count1 = count1 + K(i);
                
                for k1 = 1:K(i)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, i}(k1) = exp(- z);
                        newgstar{1, i}(k1) = - log(newJstar{1, i}(k1));
                    else
                        newJstar{1, i}(k1) = b - log(rand);
                        newgstar{1, i}(k1) = - log(b) * exp(- (newJstar{1, i}(k1) - b));
                    end
                end
                
                newfstar{1, i} = expint(newJstar{1, i});
                x2 = exp(- newJstar{1, i} .* (v * exp(newbetastar{1, i}(:, x)')));
                
                newlogtheta_comp(i) = sum(log(1 - x2.*newfstar{1, i}./(a*newgstar{1, i})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        newloglike = newlogtheta + length(numb) * log(newM);
        loglike = logtheta + length(numb) * log(M);
        
        logaccept = newloglike - loglike;
        logaccept = logaccept + log(newM) - log(M) - (newM - M);
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end
    
    if ( rand < accept )
        M = newM;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar = newbetastar;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    logMsd = logMsd + 1 / it^(0.55) * (accept - 0.234);
    
    Maccept = Maccept + accept;
    Mcount = Mcount + 1;
    
    
    
    mean1 = (sumy ./ (mix_a * sigmasq_loc) + mix_mu / (1 - mix_a)) ./ (numb ./ (mix_a * sigmasq_loc) + 1 / (1 - mix_a));
    var1 = mix_sigmasq ./ (numb ./ (mix_a * sigmasq_loc) + 1 / (1 - mix_a));
    mustar = mean1 + sqrt(var1) .* randn(length(numb), 1);
    
    
    % Update mix_a
    trans = log(mix_a) - log(1 - mix_a);
    newtrans = trans + exp(logmix_asd) * randn;
    newmix_a = exp(newtrans) / (1 + exp(newtrans));
    
    loglike = - 0.5 * n * log(mix_a) - 0.5 * sum((target - mustar(s)).^2 ./ (mix_a * mix_sigmasq * sigmasq_loc(s)));
    loglike = loglike - 0.5 * length(numb) * log(1 - mix_a) - 0.5 * sum((mustar - mix_mu).^2) / ((1 - mix_a) * mix_sigmasq);
    newloglike = - 0.5 * n * log(newmix_a) - 0.5 * sum((target - mustar(s)).^2 ./ (newmix_a * mix_sigmasq * sigmasq_loc(s)));
    newloglike = newloglike - 0.5 * length(numb) * log(1 - newmix_a) - 0.5 * sum((mustar - mix_mu).^2) / ((1 - newmix_a) * mix_sigmasq);
    
    logaccept = newloglike - loglike;
    logaccept = logaccept - log(1 / newmix_a + 1 / (1 - newmix_a)) + log(1 / mix_a + 1 / (1 - mix_a));
    
    accept = 1;
    if ( isreal(logaccept) == 0 )
        accept = 0;
    elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
        accept = 0;
    elseif ( logaccept < 0 )
        accept = exp(logaccept);
    end
    
    if ( rand < accept )
        mix_a = newmix_a;
    end
    
    mix_aaccept = mix_aaccept + accept;
    mix_acount = mix_acount + 1;
    
    logmix_asd = logmix_asd + 1 / it^0.6 * (accept - 0.234);
    
    % Update mix_sigmasq
    alpha1 = 0.5 * n + 0.5 * length(numb);
    beta1 = 0.5 * sum((target - mustar(s)).^2 ./ (mix_a * sigmasq_loc(s))) + 0.5 * sum((mustar - mix_mu).^2) / (1 - mix_a);
    mix_sigmasq = 1 / gamrnd(alpha1, 1 / beta1);
    
    % Update mix_mu
    mix_mu = mean(mustar) + sqrt(mix_sigmasq / length(numb)) * randn;
    
    if ( DCV == 1 )
        % Update sigmasq_loc
        for i = 1:length(numb)
            alpha1 = 0.5 * numb(i) + 0.5 * sigmasqnu;
            beta1 = 0.5 * (sumysq(i) - 2 * sumy(i) * mustar(i) + numb(i) * mustar(i)^2) / (mix_a * mix_sigmasq) + 0.5 * sigmasqnu;
            
            sigmasq_loc(i) = 1 / gamrnd(alpha1, 1 / beta1);
        end
    end
    
    
    if ( it > burnin )
        if ( mod(it - burnin, every) == 0 )
            numbclust((it - burnin) / every) = length(unique(s));
            holdsigmasq_stat((it - burnin) / every) = sigmasq_stat;
            holdsigmasq_stat((it - burnin) / every) = sigmasq_stat;
            holdlengthscale((it - burnin) / every) = lengthscale;
            holdv((it - burnin) / every, :) = v;
            holdmix_mu((it - burnin) / every) = mix_mu;
            holdmix_sigmasq((it - burnin) / every) = mix_sigmasq;
            holdmix_a((it - burnin) / every) = mix_a;
            holdM((it - burnin) / every) = M;
            
            meanstar = (sumy ./ (mix_a * sigmasq_loc)) ./ (numb ./ (mix_a * sigmasq_loc) + 1 / (1 - mix_a));
            varstar = mix_sigmasq ./ (numb ./ (mix_a * sigmasq_loc) + 1 / (1 - mix_a));            
            
            for i = 1:ndata
                probstar = J .* exp(beta(:, i)) / sum(J .* exp(beta(:, i)));
                var1 = varstar + mix_a * mix_sigmasq * sigmasq_loc;
                
                for j = 1:length(ypred)
                    fpred(i, j) = fpred(i, j) + sum(probstar .* normpdf(ypred(j), meanstar, sqrt(var1)));
                end
                
                mupred(i, (it - burnin) / every) = sum(probstar .* meanstar);
            end
        end
    end
end

fpred = fpred / numbofits;

figure(1)
pcolor(data, ypred, fpred')
shading flat
hold on
plot(data(x), target, '.')
hold off

figure(2)
plot(ypred, fpred)

figure(3)
plot(holdM)

figure(4)
plot(holdsigmasq_stat)

figure(5)
plot(holdlengthscale)

low = zeros(1, 94);
upp = zeros(1, 94);
med = zeros(1, 94);
for i = 1:94
    quan = quantile(mupred(i, :), [0.025 0.5 0.975]);
    low(i) = quan(1);
    med(i) = quan(2);
    upp(i) = quan(3);
end
figure(6)
fill([1:94 94:-1:1],[low upp(end:-1:1)],[0.8 0.8 0.8])
hold on
plot(1:94, med, 'k-')
hold off

